"""Combine Game and Board

Revision ID: 1a92e2bbd632
Revises: b05bc6012c4d
Create Date: 2021-10-21 10:58:29.322759

"""
import sqlalchemy as sa
from alembic import op
from sqlalchemy.sql.expression import text

# revision identifiers, used by Alembic.
revision = '1a92e2bbd632'
down_revision = 'b05bc6012c4d'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('cell', sa.Column('game_id', sa.Integer(), nullable=True))
    op.create_foreign_key(None, 'cell', 'game', ['game_id'], ['id'])
    op.add_column(
        'game', sa.Column('board_height', sa.SmallInteger(), nullable=True)
    )

    connection = op.get_bind()
    connection.execute(
        text(
            "UPDATE cell SET game_id=game.id "
            "FROM game WHERE cell.board_id=game.board_id "
        )
    )
    connection.execute(
        text(
            "UPDATE game SET board_height=board.height "
            "FROM board WHERE game.board_id=board.id "
        )
    )

    op.alter_column('cell', 'game_id', nullable=False)
    op.alter_column('game', 'board_height', nullable=False)
    op.create_check_constraint(
        'board_height_check', 'game', 'board_height BETWEEN 4 AND 30'
    ),
    op.create_unique_constraint(
        None, 'cell', ['game_id', 'row_index', 'col_index']
    )
    op.drop_constraint(
        'cell_board_id_row_index_col_index_key', 'cell', type_='unique'
    )
    op.drop_constraint('cell_board_id_fkey', 'cell', type_='foreignkey')
    op.drop_constraint('game_board_id_key', 'game', type_='unique')
    op.drop_constraint('game_board_id_fkey', 'game', type_='foreignkey')
    op.drop_column('game', 'board_id')
    op.drop_column('cell', 'board_id')
    op.drop_table('board')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        'board',
        sa.Column('id', sa.INTEGER(), autoincrement=True, nullable=False),
        sa.Column('width', sa.SMALLINT(), autoincrement=False, nullable=False),
        sa.Column(
            'height', sa.SMALLINT(), autoincrement=False, nullable=False
        ),
        sa.CheckConstraint(
            '(height >= 4) AND (height <= 30)', name='board_height_check'
        ),
        sa.CheckConstraint(
            '(width >= 4) AND (width <= 30)', name='board_width_check'
        ),
        sa.PrimaryKeyConstraint('id', name='board_pkey')
    )
    op.add_column(
        'game',
        sa.Column(
            'board_id',
            sa.INTEGER(),
            autoincrement=False,
            nullable=True
        )
    )
    op.create_unique_constraint('game_board_id_key', 'game', ['board_id'])

    connection = op.get_bind()
    connection.execute(
        text(
            "WITH cte AS ("
            "   SELECT "
            "   id, "
            "   ROW_NUMBER() OVER (ORDER BY id) AS board_id "
            "   FROM game"
            ") "
            "UPDATE game "
            "SET board_id = cte.board_id "
            "FROM cte "
            "WHERE game.id = cte.id"
        )
    )
    connection.execute(
        text(
            "INSERT INTO board (id, height, width) "
            "SELECT board_id, board_height, COUNT(cell.game_id)/board_height "
            "FROM game LEFT JOIN cell ON (game.id=cell.game_id) "
            "GROUP BY (cell.game_id, board_height, board_id)"
        )
    )

    op.add_column(
        'cell',
        sa.Column(
            'board_id',
            sa.INTEGER(),
            autoincrement=False,
            nullable=True
        )
    )

    connection.execute(
        text(
            "UPDATE cell SET board_id=game.board_id "
            "FROM game WHERE cell.game_id=game.id "
        )
    )

    op.create_foreign_key(
        'cell_board_id_fkey', 'cell', 'board', ['board_id'], ['id']
    )
    op.create_foreign_key(
        'game_board_id_fkey', 'game', 'board', ['board_id'], ['id']
    )
    op.alter_column('game', 'board_id', nullable=False)
    op.alter_column('cell', 'board_id', nullable=False)
    op.drop_constraint(
        'board_height_check', 'game', type_='check'
    )
    op.create_unique_constraint(
        'cell_board_id_row_index_col_index_key',
        'cell',
        ['board_id', 'row_index', 'col_index']
    )
    op.drop_column('cell', 'game_id')
    op.drop_column('game', 'board_height')
    # ### end Alembic commands ###
